#ifndef MYEC2_H_INCLUDED
#define MYEC2_H_INCLUDED

#include "stdafx.h"
#include <curl/curl.h>


namespace MyS3MultiPartUploader
{
	struct PartDesc
	{
		size_t partId;
		string md5;
		string eTag;
		size_t offset;
		size_t current;
		size_t size;
		FILE* stream;
	};

	//typedef map<size_t, PartDesc> IndexPartDescMap;
	typedef vector<PartDesc> PartDescVector;

	struct MultiPartDesc
	{
		string bucket;
		string object;
		FILE*  stream;
		string uploadId;
		size_t partCount;
		string contentType;
		PartDescVector partDescVector;
		string eTag;
	};

#define MYS3_FILE_BUFFER_SIZE 1024
    class MyS3
    {
        friend int mySimpleXmlCallback(const char *elementPath, const char *data, int dataLen, void *callbackData);
    private:
		static char* HttpVerb[3];

        static char accessKey[32];
        static char secretAccessKey[64];
        static char keyPath[256];
        static bool isKeyOK;
        char buffer[1024];
        //char ip[32];
        MultiPartDesc multiPartDesc;

        string int2string(int number);
		void calculateMD5(FILE* stream, int index);
		void addFileContentType(FILE* stream);
		void addDefaultHttpHeader(curl_slist*& slist, const string& strTimestamp, const string& strSignature);
		string doSignature(const string& strToSign);
        void initializeKey(const char* newKeyPath);
        bool initialize(const string& bucketName, const string& objectName, const string& fileName, size_t nSuggestedPartNumber);
		bool uploadMultiPart();
		bool doUploadMultiPart(int index);
        bool readKeyFile();

        std::string getTimestamp();
        bool initMultiPartUpload();

        bool completeMultiPartUpload();
        string createCompletePartBody();

    public:
        StringMap headerMap;
        MyS3(char* newKeyPath = NULL);
        bool multiPartUpload(const string& bucketName, const string& objectName, const string& fileName, size_t nSuggestedPartNumber);
    };

}


#endif // MYEC2_H_INCLUDED
